<?php

 /* script represents single function which returns certain snmp counter(gauge) on apropriate ip-host. 
    Moreover - it precisely counts how long that query took. This allows to measure snmp traffic on server-side.
    
    snmp data can be retrieved using php-snmp module(default,preferred,fast) or systems native snmpget(slower)
    usage: "print_r(snmp_data('127.0.0.1','public','.1.3.6.1.2.1.2.2.1.10.1'));"
    
    function will return array containing two values: [0]->snmp_counter_value and [1]->query_time
    author: amnesiac@netzond.com
 */

DEFINE('SNMP_TIMEOUT_us',2000000);//[micro-seconds] snmp timeout period for unsuccesful queries in php-snmp mode
DEFINE('SNMP_TIMEOUT_s',2);//[seconds] snmp timeout period for unsuccesful queries in system snmp mode
DEFINE('REFRESH_INTERVAL',1);//[seconds] snmp_traffic=(snmp_counter_old+snmp_counter_new)/refresh_interval
DEFINE('MULTIPLIER',8);//convert Bytes into Bits (set to 1 to disable conversion)

/* we intend to use php5_snmp module because if's much faster*/
if (is_array(get_extension_funcs("snmp"))) DEFINE('PHP5_SNMP',true);
else DEFINE('PHP5_SNMP',false);

/*
 * $com - snmp community, $oid - snmp object indentifier
 * returns array ( 0=>counter_value, 1 => query_time )
 */
function snmp_data($ip,$com,$oid) {
    $timePrev=time() + microtime();
    
    if (PHP5_SNMP) {
	$counter=snmp2_get($ip,$com,$oid,SNMP_TIMEOUT_us,1);
    } else {
	$counter=@exec("/usr/local/bin/snmpget -O n -t ".SNMP_TIMEOUT_s." -v 2c -c $com $ip $oid");
    }
    
    $counter=trim(substr($counter,strrpos($counter,":")+2));

    $timeNow=time() + microtime() - $timePrev;
    $result[]=$counter;
    $result[]=$timeNow;
    
    return $result;
}

?>
